;;; Scheme48/Scsh module interface for tiny-CLOS
;; Emilio Lopes <eclig@gmx.net>

(define-interface tiny-clos-interface
  (export make-class
          make-generic
          make-method
          add-method

          make
          initialize

          slot-ref
          slot-set!

          instance?
          class-of
          class-direct-supers
          class-direct-slots
          class-cpl
          class-slots

          generic-methods

          method-specializers
          method-procedure

          allocate-instance
          compute-cpl
          compute-slots
          compute-getter-and-setter

          compute-apply-generic
          compute-methods
          compute-method-more-specific?
          compute-apply-methods

          <top>
          <class>
          <object>
          <procedure-class>
          <entity-class>
          <generic>
          <method>

          <primitive-class>
          <pair>
          <null>
          <symbol>
          <boolean>
          <procedure>
          <number>
          <vector>
          <char>
          <string>
          <input-port>
          <output-port>))

(define-structure tiny-clos tiny-clos-interface
  (open scheme
        srfi-1
        srfi-23
        sort)
  (files support std-lin tiny-clos))

(define-structure tiny-clos-c3 tiny-clos-interface
  (open scheme
        srfi-1
        srfi-23
        sort)
  (files support c3-lin tiny-clos))
